# coding: utf-8

"""
    Wink API

    ## APIs Not every integrator needs every APIs. For that reason, we have separated APIs into context.  - [Affiliate](/affiliate): All APIs related to selling travel inventory as an affiliate. - [Analytics](/analytics): All APIs related to tracking metrics across a wide variety of data source segments including, more entertaining, leaderboard metrics. - [Booking](/booking): All APIs related to creating platform bookings. - [Channel Manager](/channel-manager): All APIs related to channel managers who want to integrate with our platform. - [Extranet](/extranet): All APIs related to managing travel inventory and suppliers. - [Inventory](/inventory): All APIs related to retrieve known travel inventory as it was found using the Lookup API.. - [Lookup](/lookup): All APIs related to locating inventory by region, locale and property flags. - [Reference](/reference): All APIs related to retrieving platform-supported taxonomies. - [TripPay](/reactive): All APIs related to TripPay account management, booking, mapping and integration features.  ## SDKs We are actively working on supporting the most used languages out there. If you don't see your language here, reach out to us with a request to officially add your language. In the meantime, if you want to roll your own SDK, you can do so by downloading the OpenAPI spec and using one of the many available OpenAPI generators available: [https://openapi-generator.tech/docs/generators](https://openapi-generator.tech/docs/generators).  - Java SDK [https://github.com/wink-travel/wink-sdk-java](https://github.com/wink-travel/wink-sdk-java)  ## Usage These features are made available to you via a [REST API](https://en.wikipedia.org/wiki/Representational_state_transfer). This API is language agnostic.  ## Versioning We chose to version our endpoints in a way that we hope affects your integration with us the least. You request the version of our API you wish to work with via the `Wink-Version` header. When it's time for you to upgrade, you only have to change the version number to get access to our updated endpoints.  ## Release history - Follow updates on Github: https://github.com/wink-travel/wink-sdk-java/blob/master/CHANGELOG.md   # Channel Manager API Wink exposes a secured REST-based, JSON API to its channel manager partners. The connection is \"channel-wide\". Partners are free to integrate with the REST-based API using any programming language.  # Intended Audience This document is intended for external channel partners who wish to integrate with Wink.  # Requirements - Active account with Wink. Sign up for your Channel Manager account:    - Staging: [https://staging-studio.wink.travel](https://staging-studio.wink.travel).    - Production: [https://studio.wink.travel](https://studio.wink.travel). - Active application. An application provides you with Oauth2 credentials you can pass to our endpoints. One is already created for you upon account creation. - Your production IP numbers. They need to be whitelisted before you can talk to our production environment.  # Performance A particular attention to performance should be given when integrating with this API. A few things to be aware of: - Enable gzip compression to make payloads smaller. - Fewer large REST calls are preferred to many small ones. E.g. It is better to update many dates instead of individual dates. - It is possible to update both rate and availability with a single request. - Request only date ranges that you will use. There is no need to request an entire year if you will only be working with the first seven days.  ## Reservation notification (PUSH) Wink supports PUSH notifications to communicate reservations. We also support BASIC AUTH to your endpoint. If you want to enable PUSH, add your PUSH endpoint and credentials (optional) to your account.

    The version of the OpenAPI document: 30.17.1
    Contact: bjorn@wink.travel
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from datetime import date
from pydantic import BaseModel, ConfigDict, Field, StrictBool, StrictFloat, StrictInt, StrictStr
from typing import Any, ClassVar, Dict, List, Optional, Union
from typing_extensions import Annotated
from wink_sdk_channel_manager.models.variable_charge import VariableCharge
from typing import Optional, Set
from typing_extensions import Self

class PropertyRate(BaseModel):
    """
    PropertyRate
    """ # noqa: E501
    identifier: Optional[StrictStr] = None
    property_identifier: Annotated[str, Field(min_length=1, strict=True)] = Field(alias="propertyIdentifier")
    room_rate_identifier: Annotated[str, Field(min_length=1, strict=True)] = Field(alias="roomRateIdentifier")
    guest_room_identifier: Annotated[str, Field(min_length=1, strict=True)] = Field(alias="guestRoomIdentifier")
    rate_plan_identifier: Annotated[str, Field(min_length=1, strict=True)] = Field(alias="ratePlanIdentifier")
    amount: Union[StrictFloat, StrictInt]
    currency_code: Annotated[str, Field(min_length=1, strict=True)] = Field(alias="currencyCode")
    master: StrictBool
    closed_on_arrival: StrictBool = Field(alias="closedOnArrival")
    closed_on_departure: StrictBool = Field(alias="closedOnDeparture")
    var_date: date = Field(alias="date")
    quantity: Optional[StrictInt] = None
    min_occupancy: Optional[StrictInt] = Field(default=None, alias="minOccupancy")
    max_occupancy: Optional[StrictInt] = Field(default=None, alias="maxOccupancy")
    min_length_of_stay: Optional[StrictInt] = Field(default=None, alias="minLengthOfStay")
    max_length_of_stay: Optional[StrictInt] = Field(default=None, alias="maxLengthOfStay")
    single_occupancy_rate_modifier: Optional[VariableCharge] = Field(default=None, alias="singleOccupancyRateModifier")
    extra_pax_rate_modifier: Optional[VariableCharge] = Field(default=None, alias="extraPaxRateModifier")
    extra_child_rate_modifier: Optional[VariableCharge] = Field(default=None, alias="extraChildRateModifier")
    __properties: ClassVar[List[str]] = ["identifier", "propertyIdentifier", "roomRateIdentifier", "guestRoomIdentifier", "ratePlanIdentifier", "amount", "currencyCode", "master", "closedOnArrival", "closedOnDeparture", "date", "quantity", "minOccupancy", "maxOccupancy", "minLengthOfStay", "maxLengthOfStay", "singleOccupancyRateModifier", "extraPaxRateModifier", "extraChildRateModifier"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of PropertyRate from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of single_occupancy_rate_modifier
        if self.single_occupancy_rate_modifier:
            _dict['singleOccupancyRateModifier'] = self.single_occupancy_rate_modifier.to_dict()
        # override the default output from pydantic by calling `to_dict()` of extra_pax_rate_modifier
        if self.extra_pax_rate_modifier:
            _dict['extraPaxRateModifier'] = self.extra_pax_rate_modifier.to_dict()
        # override the default output from pydantic by calling `to_dict()` of extra_child_rate_modifier
        if self.extra_child_rate_modifier:
            _dict['extraChildRateModifier'] = self.extra_child_rate_modifier.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of PropertyRate from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "identifier": obj.get("identifier"),
            "propertyIdentifier": obj.get("propertyIdentifier"),
            "roomRateIdentifier": obj.get("roomRateIdentifier"),
            "guestRoomIdentifier": obj.get("guestRoomIdentifier"),
            "ratePlanIdentifier": obj.get("ratePlanIdentifier"),
            "amount": obj.get("amount"),
            "currencyCode": obj.get("currencyCode"),
            "master": obj.get("master"),
            "closedOnArrival": obj.get("closedOnArrival"),
            "closedOnDeparture": obj.get("closedOnDeparture"),
            "date": obj.get("date"),
            "quantity": obj.get("quantity"),
            "minOccupancy": obj.get("minOccupancy"),
            "maxOccupancy": obj.get("maxOccupancy"),
            "minLengthOfStay": obj.get("minLengthOfStay"),
            "maxLengthOfStay": obj.get("maxLengthOfStay"),
            "singleOccupancyRateModifier": VariableCharge.from_dict(obj["singleOccupancyRateModifier"]) if obj.get("singleOccupancyRateModifier") is not None else None,
            "extraPaxRateModifier": VariableCharge.from_dict(obj["extraPaxRateModifier"]) if obj.get("extraPaxRateModifier") is not None else None,
            "extraChildRateModifier": VariableCharge.from_dict(obj["extraChildRateModifier"]) if obj.get("extraChildRateModifier") is not None else None
        })
        return _obj


